VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Tile tutorial"
   ClientHeight    =   6735
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8955
   LinkTopic       =   "Form1"
   ScaleHeight     =   449
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   597
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox lstTiles 
      Height          =   315
      Left            =   5700
      Style           =   2  'Dropdown-Liste
      TabIndex        =   7
      Top             =   5940
      Width           =   2175
   End
   Begin VB.CommandButton cmdClearMap 
      Caption         =   "Clear map"
      Height          =   495
      Left            =   720
      TabIndex        =   6
      Top             =   2820
      Width           =   1335
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save map"
      Height          =   495
      Left            =   720
      TabIndex        =   4
      Top             =   2040
      Width           =   1335
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load map"
      Height          =   495
      Left            =   720
      TabIndex        =   5
      Top             =   960
      Width           =   1335
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   495
      Left            =   720
      TabIndex        =   2
      Top             =   1500
      Width           =   1335
   End
   Begin VB.PictureBox Front 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   4860
      Left            =   3240
      ScaleHeight     =   320
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   0
      Top             =   960
      Width           =   4860
   End
   Begin VB.Label lblInfo 
      Caption         =   "Paint this this:"
      Height          =   255
      Index           =   1
      Left            =   4380
      TabIndex        =   8
      Top             =   6000
      Width           =   1215
   End
   Begin VB.Label lblInfo 
      Caption         =   "Control (load before running!)"
      Height          =   255
      Index           =   2
      Left            =   480
      TabIndex        =   3
      Top             =   540
      Width           =   2475
   End
   Begin VB.Label lblInfo 
      Caption         =   "Use left button to draw, right button to drag camera"
      Height          =   315
      Index           =   0
      Left            =   3240
      TabIndex        =   1
      Top             =   540
      Width           =   4875
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Used for camera movement
    Dim X2 As Long
    Dim Y2 As Long
Public Sub Redraw()
    'Draw map
    mMap.Draw
    
    'Update ("flip") display
    Front.Refresh
End Sub

Private Sub cmdLoad_Click()
    Dim A As Long
    
    'Call load  function
    mMap.LoadData App.Path & "\Test.map"
    
    'Now that we loaded the tiles, load the pictures for them
    mTiles.LoadResources
    
    'Load the tiles into the editor list
    lstTiles.Clear
    For A = 1 To TileCount: lstTiles.AddItem Tile(A).PictureFile: Next
End Sub

Private Sub cmdClearMap_Click()
    Dim A As Long
    
    With Map
        'Set new size
        .w = 64
        .h = 64
        ReDim .Data(.w * .h)
        
        'Clear map
        For A = 0 To (.w * .h): .Data(A) = 1: Next
    End With
End Sub

Private Sub cmdRun_Click()
    'This is the "main loop"
    While DoEvents
        'Update animations
        mTiles.Animate
        
        'Update display
        Redraw
    Wend
End Sub

Private Sub cmdSave_Click()
    'Call save function
    mMap.SaveData App.Path & "\Test.map"
End Sub

Private Sub Form_Load()
    'Initialize modules
    mBitmap.Initialize frmMain
    mMap.Reset
    mTiles.Reset
    mCamera.Reset frmMain.Front
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Release modules
    mTiles.Reset
    mMap.Reset
    mBitmap.Reset
End Sub

Private Sub Front_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next 'Never let edit functions crash your program

    Dim TempX As Long
    Dim TempY As Long
    Dim Index As Long
    Dim TileIndex As Long
    
    Select Case Button
    Case 1 'Left button
        'Get mouse position in tiles
        TempX = CLng((X - (TileSize / 2)) / TileSize) + Camera.X
        TempY = CLng((Y - (TileSize / 2)) / TileSize) + Camera.Y
        '(subtract the half TileSize to get the middle of the tile)
        
        'Check position
        If TempX < 0 Then: Exit Sub
        If TempY < 0 Then: Exit Sub
        If TempX >= Map.w Then: Exit Sub
        If TempY >= Map.h Then: Exit Sub
        
        'Get selected tile index
        TileIndex = lstTiles.ListIndex + 1
        If TileIndex < 1 Then: Exit Sub
        
        'Set the tile there
        Map.Data(TempY * Map.w + TempX) = TileIndex
    
    Case 2 'Right button
        X2 = CLng(X)
        Y2 = CLng(Y)
    End Select
End Sub





Private Sub Front_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case Button
    Case 1: 'Left button
        'Forward event when painting tiles
        Front_MouseDown Button, Shift, X, Y
    
    Case 2: 'Right button
        'Drag camera
        mCamera.LookAt Camera.X + CLng(X) - X2, Camera.Y + CLng(Y) - Y2
        
        'Store new cursor position
        X2 = X
        Y2 = Y
    End Select
End Sub


