Attribute VB_Name = "mCamera"
Option Explicit

'Type
    Public Type tCamera
        'Camera position
        x As Long
        y As Long
        
        'Screen size
        w As Long 'W means width
        h As Long 'H means height
        
        'Number of tiles that fit on screen
        TilesX As Long
        TilesY As Long
        
        'Front buffer
        FrontDC As Long
    End Type

'Variables
    Public Camera As tCamera

Public Sub LookAt(iX As Long, iY As Long)
    'Store position
    Camera.x = iX
    Camera.y = iY
    
    'Check upper boundaries
    If (Camera.x + Camera.TilesX) > Map.w Then: Camera.x = (Map.w - Camera.TilesX)
    If (Camera.y + Camera.TilesY) > Map.h Then: Camera.y = (Map.h - Camera.TilesY)
    
    'Check lower boundaries
    If Camera.x < 0 Then: Camera.x = 0
    If Camera.y < 0 Then: Camera.y = 0
End Sub

Public Sub Reset(iFront As PictureBox)
    With Camera
        'Get viewport size
        .w = iFront.ScaleWidth
        .h = iFront.ScaleHeight
        
        'Calculate number of visible tiles
        .TilesX = (.w / TileSize)
        .TilesY = (.h / TileSize)
        
        'Get device context
        .FrontDC = iFront.hDC
    End With
End Sub

