Attribute VB_Name = "mMap"
Option Explicit

'Types
    Public Type tMap
        w As Long 'W stands for width
        h As Long 'H stands for height
        
        Data() As Long
    End Type

'Variables
    Public Map As tMap

Public Sub CreateMap(iW As Long, iH As Long)
    With Map
        'Get size
        .w = iW
        .h = iH
        
        'Create map
        ReDim .Data(.w * .h)
    End With
End Sub

Public Sub Reset()
    'Reset map
    Map.w = 0
    Map.h = 0
    Erase Map.Data
End Sub

Public Sub Draw()
    Dim x As Long
    Dim y As Long
    
    Dim Index As Long
    Dim TileIndex As Long
    
    With Map
        'Calculate map index from the camera positon
        Index = (Camera.y * .w) + Camera.x
        
        'Draw the map
        For y = 0 To Camera.TilesY - 1
            For x = 0 To Camera.TilesX - 1
                'Get tile index
                TileIndex = .Data(Index)
                
                'Draw tile
                BitBlt Camera.FrontDC, _
                    x * TileSize, y * TileSize, _
                    TileSize, TileSize, _
                    Bitmap(Tile(TileIndex).Bitmap).Picture.DC, _
                    Tile(TileIndex).ActFrame * TileSize, 0, _
                    vbSrcCopy
                
                'Next tile
                Index = Index + 1
            Next
            
            'Get next line start
            Index = Index + .w - Camera.TilesX
        Next
    End With
End Sub
Public Function SaveData(iFileName As String) As Boolean
On Error GoTo 1

    Dim FileNumber As Integer
    
    'Open the specified file
    FileNumber = FreeFile
    Open iFileName For Binary As FileNumber
        'Write data
        WriteData FileNumber
    Close FileNumber
    
    'We're done
    SaveData = True
    Exit Function

1  'Catched an error
    SaveData = False
End Function

Public Function LoadData(iFileName As String) As Boolean
On Error GoTo 1

    Dim FileNumber As Integer
    
    'Check existance
    If Dir(iFileName, vbNormal) = "" Then: GoTo 1
    
    'Open the specified file
    FileNumber = FreeFile
    Open iFileName For Binary As FileNumber
        'Read data
        ReadData FileNumber
    Close FileNumber
    
    'We're done
    LoadData = True
    Exit Function

1  'Catched an error
    LoadData = False
End Function

Public Sub SetTile(iX As Long, iY As Long, Index As Long)
    'Set tile at the specified 0-based position
    Map.Data(iY * Map.w + iX) = Index
End Sub

Public Sub WriteData(iFileNumber As Integer)
    'Write tile set
    mTiles.WriteData iFileNumber
    
    With Map
        'Write map size
        Put iFileNumber, , .w
        Put iFileNumber, , .h
        
        'Write map data
        Put iFileNumber, , .Data
    End With
End Sub

Public Sub ReadData(iFileNumber As Integer)
    'Read tile set
    mTiles.ReadData iFileNumber
        
    With Map
        'Read m size
        Get iFileNumber, , .w
        Get iFileNumber, , .h
        
        'Allocate memory
        ReDim .Data(.w * .h)
        
        'Read map data
        Get iFileNumber, , .Data
    End With
End Sub



